#include <iostream>
#include <vector>
#include <cassert>

using namespace std;
const int nmax = 305;
string s[nmax];
int dp[2][nmax][nmax];
int n;
int diagonalCoordToCellColumn(int diag, int line){
    return diag + 1 - line;
}
int main(){
    //freopen("data.in", "r", stdin);
    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        s[i] = " " + s[i];
    }
    for(int lineA=0; lineA <= 2; lineA++)
        for(int lineB=0; lineB <= 2; lineB++)
            dp[1][lineA][lineB] = -(1<<30);
    dp[1][1][1] = 1;
    int use = 0;
    for(int diagonal = 2; diagonal <= 2*n-1; diagonal++){
        int minLine, maxLine;
        if(diagonal<=n){
            minLine = 1;
            maxLine = diagonal;
        } else {
            minLine = diagonal - n;
            maxLine = n;
        }
        for(int lineA=minLine; lineA <= maxLine; lineA++){
            int minLineB = lineA + 1 - (diagonal == 2*n-1);
            for(int lineB=minLineB; lineB <= maxLine; lineB++){
                int colA = diagonalCoordToCellColumn(diagonal, lineA);
                int colB = diagonalCoordToCellColumn(diagonal, lineB);
                int same = (s[lineA][colA] == s[lineB][colB]);
                dp[use][lineA][lineB] = max(
                                            max(dp[1-use][lineA][lineB-1], dp[1-use][lineA][lineB]),
                                            max(dp[1-use][lineA-1][lineB-1], dp[1-use][lineA-1][lineB])
                                        ) + same;
            }
        }
        for(int lineA=minLine - 1; lineA <= maxLine + 1; lineA++)
            for(int lineB=lineA; lineB <= maxLine + 1; lineB++)
                dp[1-use][lineA][lineB] = -(1<<30);
        use = 1 - use;
    }
    cout<<dp[1-use][n][n];
    return 0;
}
