#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9;

int backtracking(int x, int y, int xx, int yy, const vector<string> &lines) {
  if(x >= (int)lines.size() || y >= (int)lines[x].size() || xx >= (int)lines.size() || yy >= lines[xx].size()) {
    return -inf;
  }
  if(x == xx && y == yy && (x != 0 || y != 0) && (x != (int)lines.size() - 1 || y != (int)lines[x].size() - 1)) {
    return -inf;
  }
  if(x == (int)lines.size() - 1 && y == (int)lines[x].size() - 1 && xx == (int)lines.size() - 1 && yy == (int)lines[xx].size() - 1) {
    return (lines[x][y] == lines[xx][yy]);
  }
  return (lines[x][y] == lines[xx][yy]) + max(
      max(
        backtracking(x + 1, y, xx + 1, yy, lines),
        backtracking(x + 1, y, xx, yy + 1, lines)
      ),
      max(
        backtracking(x, y + 1, xx + 1, yy, lines),
        backtracking(x, y + 1, xx, yy + 1, lines)
      )
  );
}

int main() {
  int n;
  cin >> n;

  vector<string> lines(n, "");

  for(auto &it:lines){
    cin >> it;
  }

  cout << backtracking(0, 0, 0, 0, lines);

  return 0;
}
